"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NotificationDrawerListItem = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var React = _interopRequireWildcard(require("react"));

var _reactStyles = require("@patternfly/react-styles");

var _notificationDrawer = _interopRequireDefault(require("@patternfly/react-styles/css/components/NotificationDrawer/notification-drawer"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var NotificationDrawerListItem = function NotificationDrawerListItem(_ref) {
  var children = _ref.children,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$isHoverable = _ref.isHoverable,
      isHoverable = _ref$isHoverable === void 0 ? true : _ref$isHoverable,
      _ref$isRead = _ref.isRead,
      isRead = _ref$isRead === void 0 ? false : _ref$isRead,
      _ref$onClick = _ref.onClick,
      _onClick = _ref$onClick === void 0 ? function (event) {
    return undefined;
  } : _ref$onClick,
      _ref$tabIndex = _ref.tabIndex,
      tabIndex = _ref$tabIndex === void 0 ? 0 : _ref$tabIndex,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? 'default' : _ref$variant,
      props = _objectWithoutProperties(_ref, ["children", "className", "isHoverable", "isRead", "onClick", "tabIndex", "variant"]);

  return React.createElement("li", _extends({}, props, {
    className: (0, _reactStyles.css)(_notificationDrawer["default"].notificationDrawerListItem, isHoverable && _notificationDrawer["default"].modifiers.hoverable, (0, _reactStyles.getModifier)(_notificationDrawer["default"].modifiers, variant), isRead && _notificationDrawer["default"].modifiers.read, className),
    tabIndex: tabIndex,
    onClick: function onClick(e) {
      return _onClick(e);
    }
  }), children);
};

exports.NotificationDrawerListItem = NotificationDrawerListItem;
NotificationDrawerListItem.propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  isHoverable: _propTypes["default"].bool,
  isRead: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  tabIndex: _propTypes["default"].number,
  variant: _propTypes["default"].oneOf(['success', 'danger', 'warning', 'info', 'default'])
};
//# sourceMappingURL=NotificationDrawerListItem.js.map